/** Classe AbulEduExerciceWidgetTelecommandeV1
  * @author 2011-2012 Eric Seigne <eric.seigne@ryxeo.com>
  * @author 2012 Philippe Cadaugade <philippe.cadaugade@ryxeo.com>
  * @see The GNU Public License (GNU/GPL) v3
  *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "abuleduexercicewidgettelecommandev1.h"
#include "ui_abuleduexercicewidgettelecommandev1.h"
#include <QDebug>

AbulEduExerciceWidgetTelecommandeV1::AbulEduExerciceWidgetTelecommandeV1(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::AbulEduExerciceWidgetTelecommandeV1)
{
    m_localDebug = false;

    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }

    m_niveau = 0;
    m_teteEval = "attente";
    ui->setupUi(this);
    connect(parent,SIGNAL(dimensionsChangees()),this, SLOT(setDimensionsWidget()));
//    setParent(parent);
    raise();
    setStyleSheet("background-color: rgba(0,0,0,0);");
    setImageFond(":/abuleduexercicev1/fonds/telecommande");

    //Une astuce pour eviter de faire 7 boutons * 3 lignes pour activer les icones
    QList<AbulEduFlatBoutonV1 *> btns = findChildren<AbulEduFlatBoutonV1 *>(QRegExp(".*"));
    for(int i = 0; i < btns.count(); i++)
    {
        QString composant = btns.at(i)->objectName();
        btns.at(i)->setIconeNormale(QString(":/abuleduexercicev1/boutons/%1").arg(composant));

#ifdef __ABULEDUTABLETTEV1__MODE__
        btns.at(i)->setIconePressed(QString(":/abuleduexercicev1/boutons/%1Over").arg(composant));
#else
        btns.at(i)->setIconeSurvol(QString(":/abuleduexercicev1/boutons/%1Over").arg(composant));
#endif
        btns.at(i)->setIconeDisabled(QString(":/abuleduexercicev1/boutons/%1Disabled").arg(composant));
        btns.at(i)->setTexteAlignement(Qt::AlignLeft);
    }

#ifdef __ABULEDUTABLETTEV1__MODE__
    /// 15/01/2012 Icham -> mode tablette, pas de tooltips (pas de survol en mode tactile, et puis ça faisait des trucs bizarres parfois)
    /// 15/01/2013 iCHAM -> icones survol = icones normales
    // on cherche tous les enfants, et on leur met une chaine vide en tooltips (= desactivation)
    foreach (QWidget *obj, findChildren<QWidget*>()) {
        obj->setToolTip("");
//        if(dynamic_cast<AbulEduFlatBoutonV1*>(obj)){
//            dynamic_cast<AbulEduFlatBoutonV1*>(obj)->setIconeSurvol(dynamic_cast<AbulEduFlatBoutonV1*>(obj)->getIconeNormale());
//        }
    }
#endif

    setDimensionsWidget();
}

AbulEduExerciceWidgetTelecommandeV1::~AbulEduExerciceWidgetTelecommandeV1()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    //On recupere les deux objets qu'on a reparenté ...
    ui->framePopupQuitter->setParent(this);
    ui->framePopupNiveau->setParent(this);
    delete ui;
}

void AbulEduExerciceWidgetTelecommandeV1::abeTelecommandeClose()
{
    // a faire ou pas ?
    //setAttribute(Qt::WA_DeleteOnClose);
    close();
}

void AbulEduExerciceWidgetTelecommandeV1::changeEvent(QEvent *e)
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void AbulEduExerciceWidgetTelecommandeV1::setAbeLevel(QString s)
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    float ratio = abeApp->getAbeApplicationDecorRatio();
    m_niveau = s.toInt();
    ui->lblNiveauEnCours->setPixmap(QPixmap(":/abuleduexercicev1/niveaux/"+QString::number(m_niveau+1)).scaledToWidth(498*ratio, Qt::SmoothTransformation));
    ui->lblNiveauEnCours->update();
}

void AbulEduExerciceWidgetTelecommandeV1::setMNiveau(int niveau)
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    m_niveau = niveau;
    setDimensionsWidget();
}

void AbulEduExerciceWidgetTelecommandeV1::setMTeteEval(QString tete)
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    m_teteEval = tete;
    setDimensionsWidget();
}

void AbulEduExerciceWidgetTelecommandeV1::setDimensionsWidget()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    // Redimensionnement de l'image de la télécommande
    float ratio = abeApp->getAbeApplicationDecorRatio();
    QPixmap fond = m_imageFond;
    fond = fond.scaled(fond.size()*ratio, Qt::KeepAspectRatio, Qt::SmoothTransformation);
    setFixedSize(fond.size());

    // NSE - ajout pour positionnement correct
    move(1550*ratio,0);

    // Dimensionne et place l'image de fond
    ui->lbImageFond->setPixmap(fond);
    ui->lbImageFond->setFixedSize(fond.size());

    ui->lblImageTop->move(0,0);
    ui->lblImageTop->setPixmap(QPixmap(":/abuleduexercicev1/boutons/top").scaledToWidth(498*ratio, Qt::SmoothTransformation));
    ui->lblImageTop->resize(ui->lblImageTop->pixmap()->size());

    ui->lblNiveauEnCours->setPixmap(QPixmap(":/abuleduexercicev1/niveaux/"+QString::number(m_niveau+1)).scaledToWidth(498*ratio, Qt::SmoothTransformation));
    ui->lblNiveauEnCours->resize(ui->lblNiveauEnCours->pixmap()->size());
    if(m_localDebug) {
        qDebug()  << "  " << __FUNCTION__ << " on retaille l'image clef à "<<ui->lblNiveauEnCours->pixmap()->size();
    }

    //redimensionne les images de niveau et de réussite
    ui->lblTetePersonnage->setPixmap(QPixmap(":/abuleduexercicev1/tetes/"+m_teteEval).scaledToWidth(498*ratio, Qt::SmoothTransformation));
    ui->lblTetePersonnage->resize(ui->lblTetePersonnage->pixmap()->size());
    if(m_localDebug) {
        qDebug()  << "  " << __FUNCTION__ << " on retaille l'image asma à "<<ui->lblTetePersonnage->pixmap()->size();
    }

    //Debut du calcul du positionnement vertical
    int y = ui->lblImageTop->height();
    //================================================================================
    //Lecture du fichier conf pour placer les boutons et les textes
    QSettings config(":/abuleduexercicev1/conf/abuleduexercicev1.conf",QSettings::IniFormat);

    //Le style par defaut, attention aux %1 etc. qui sont remplaces par le .arg de fin de ligne
//    QString leStyle("border-image: url(:/abuleduexercicev1/boutons/%1);image-position: left; background-repeat: no-repeat; padding-left: %2px; text-align:left;");

    //Les composants peuvent etre de 4 types: AbulEduFlatBoutonV1, QLabel, QProgressbar ou QFrame

    int size = config.beginReadArray("telecommande");
    for(int i = 0; i < size ; i++) {
        config.setArrayIndex(i);
        QString composant(config.value("name").toString());
        //Si c'est un bouton
        if(QPointer<AbulEduFlatBoutonV1> btn = findChild<AbulEduFlatBoutonV1 *>(composant))
        {
            //On place le texte a un certain point a gauche pour ne pas recouvrir le dessin (padding left)
            btn->setTextePaddingLeft(config.value("padding").toInt()*ratio);
            btn->resize(QPixmap(QString(":/abuleduexercicev1/boutons/%1").arg(composant)).size()*ratio);
            btn->move(0,y);
            y += btn->height();
            if(m_localDebug) {
                qDebug()  << "  " << __FUNCTION__ << " " << composant<<" de taille "<<btn.data()->size()<<" en "<<btn.data()->pos();
            }
        }
        else if (QPointer<QLabel> l = findChild<QLabel *>(composant))
        {
            //On a que 3 labels : top / niveau et tete, on s'est deja charge de leur mettre la bonne taille au debut
            l->move(0,y);
            y += l->height();
            if(m_localDebug) {
                qDebug()  << "  " << __FUNCTION__ << " " << composant<<" de taille "<<l.data()->size()<<" en "<<l.data()->pos();
            }
        }
        else if (QPointer<QProgressBar> p = findChild<QProgressBar *>(composant))
        {
            p->move(config.value("padding").toInt()*ratio,y);
            p->resize(config.value("width").toInt()*ratio,config.value("height").toInt()*ratio);
            QString lestyle = config.value("style").toString();
            if(lestyle.contains("FONTSIZE")) {
                lestyle.replace("FONTSIZE", QString::number(round(config.value("height").toInt()*ratio/1.8)));
            }
            else {
                if(!lestyle.contains("font-size")) {
                    lestyle.append(QString(" font-size: %1px;").arg(QString::number(round(config.value("height").toInt()*ratio/1.8))));
                }
            }
            if(!lestyle.contains("text-align")) {
                lestyle.append(QString("text-align: center;"));
            }
            p->setStyleSheet(lestyle);
            y += p->height()+round(5*ratio);
            if(m_localDebug) {
                qDebug()  << "  " << __FUNCTION__ << " " << composant<<" de taille "<<p.data()->size()<<" en "<<p.data()->pos();
            }

        }
        else if (QPointer<QFrame> f = findChild<QFrame *>(composant)) {
            f->move(0,y);
            f->setStyleSheet("background: transparent;");
            f->resize(this->width(),config.value("height").toInt()*ratio);
            y += f->height();
        }
    }
    // Place les popup Quitter et Niveau
    //erics 20120103 : je reparente la framepopup pour qu'elle puisse déborder de la frameTelecommande sinon elle
    //s'affiche que partiellement ...
    ui->framePopupNiveau->setParent(parentWidget());
    ui->framePopupNiveau->move(1550*ratio-ui->framePopupQuitter->width(),
                                mapToParent(ui->btnNiveau->pos()).y() - ui->framePopupNiveau->height() + ui->btnNiveau->height());
    ui->framePopupNiveau->raise();

    //important de faire le raise de popupQuitter apres celui de niveau: il faut que quitter soit au dessus de niveau
    //dans le cas ou on demanderait les deux popup
    ui->framePopupQuitter->setParent(parentWidget());
    ui->framePopupQuitter->move(1550*ratio-ui->framePopupQuitter->width(),
                                mapToParent(ui->btnQuitter->pos()).y() - ui->framePopupQuitter->height() + ui->btnQuitter->height());
    ui->framePopupQuitter->raise();
}

void AbulEduExerciceWidgetTelecommandeV1::setImageFond(QString chemin)
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    m_imageFond.load(chemin);
    setDimensionsWidget();
}

void AbulEduExerciceWidgetTelecommandeV1::abeTelecommandeResize()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    setDimensionsWidget();
}

void AbulEduExerciceWidgetTelecommandeV1::keyPressEvent(QKeyEvent *event)
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    QWidget::keyPressEvent(event);
}

void AbulEduExerciceWidgetTelecommandeV1::keyReleaseEvent(QKeyEvent *event)
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    QWidget::keyReleaseEvent(event);
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnQuitter_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    ui->framePopupQuitter->setVisible(true);
    emit btnTelecommandeQuitterClicked();
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnQuitterAnnuler_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    ui->framePopupQuitter->setVisible(false);
    emit btnTelecommandeQuitterAnnulerClicked();
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnQuitterRetourMenuPrincipal_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    ui->framePopupQuitter->setVisible(false);
    emit btnTelecommandeQuitterFermerClicked();
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnAide_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    emit btnTelecommandeAideClicked();
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnNiveau_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    emit btnTelecommandeNiveauClicked();
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnNiveauAnnuler_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    emit btnTelecommandeNiveauAnnulerClicked();
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnNiveauFacile_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    emit btnTelecommandeChangeNiveau(0);
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnNiveauMoyen_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    emit btnTelecommandeChangeNiveau(1);
}

void AbulEduExerciceWidgetTelecommandeV1::on_btnNiveauDifficile_clicked()
{
    if(m_localDebug) {
        qDebug()  << __FILE__ <<  __LINE__ << __FUNCTION__;
    }
    emit btnTelecommandeChangeNiveau(2);
}
