/** Classe AbulEduIdentitesAvatarsListingV1 : affiche tous les avatars disponibles
  *
  * @author 2012 Eric Seigne <eric.seigne@ryxeo.com>
  * @see The GNU Public License (GNU/GPL) v3
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  * for more details.
  *
  * You should have received a copy of the GNU General Public License along
  * with this program; if not, write to the Free Software Foundation, Inc.,
  * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  */

#ifndef ABULEDUIDENTITESAVATARSLISTINGV1_H
#define ABULEDUIDENTITESAVATARSLISTINGV1_H

#include <QWidget>
#include <QDir>
#include <QDebug>
#include <QFileInfo>
#include "abuleduflatboutonv1.h"

namespace Ui {
class AbulEduIdentitesAvatarsListingV1;
}

class AbulEduIdentitesAvatarsListingV1 : public QWidget
{
    Q_OBJECT

public:
    explicit AbulEduIdentitesAvatarsListingV1(QWidget *parent = 0);
    ~AbulEduIdentitesAvatarsListingV1();

signals:
    void signalChoixAvatar(QString avatar);

private slots:
    void slotChoixAvatar();

private:
    Ui::AbulEduIdentitesAvatarsListingV1 *ui;
};

#endif // ABULEDUIDENTITESAVATARSLISTINGV1_H
