/**
  * AbulEduLabelV1
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "lib/abuledulabelv1/abuledulabelwidgetv1.h"
#include "lib/abuledulabelv1/abuledulabelframev1.h"
#include <QDebug>

AbulEduLabelWidgetV1::AbulEduLabelWidgetV1(QWidget *parent) :
    QFrame(parent)
{


    setFrameShape(QFrame::Box);
    gridLayout = new QGridLayout(this);
            gridLayout->setSpacing(6);
            gridLayout->setContentsMargins(11, 11, 11, 11);
            gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
            horizontalSpacer = new QSpacerItem(68, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

            gridLayout->addItem(horizontalSpacer, 0, 0, 1, 1);

            btnGauche = new AbulEduFlatBoutonV1(this);
            btnGauche->setText(trUtf8("Gauche"));
            btnGauche->setObjectName(QString::fromUtf8("btnGauche"));
            gridLayout->addWidget(btnGauche, 0, 1, 1, 1);

            btnDroite = new AbulEduFlatBoutonV1(this);
            btnDroite->setText(trUtf8("Droite"));
            btnDroite->setObjectName(QString::fromUtf8("btnDroite"));
            gridLayout->addWidget(btnDroite, 0, 2, 1, 1);

            horizontalSpacer_2 = new QSpacerItem(68, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

            gridLayout->addItem(horizontalSpacer_2, 0, 3, 1, 1);

            verticalSpacer = new QSpacerItem(20, 78, QSizePolicy::Minimum, QSizePolicy::Expanding);

            gridLayout->addItem(verticalSpacer, 1, 4, 1, 1);

            labelsScrollArea = new QScrollArea(this);
            labelsScrollArea->setObjectName(QString::fromUtf8("LabelsScrollArea"));
            labelsScrollArea->setWidgetResizable(true);
            labelsScrollArea->setAlignment(Qt::AlignCenter);
            labelsScrollArea->setFrameShape(QFrame::NoFrame);
            scrollAreaWidgetContents = new QWidget();
            scrollAreaWidgetContents->setObjectName(QString::fromUtf8("scrollAreaWidgetContents"));
            scrollAreaWidgetContents->setGeometry(QRect(0, 0, 328, 193));
            labelsScrollArea->setWidget(scrollAreaWidgetContents);

            gridLayout->addWidget(labelsScrollArea, 1, 0, 4, 4);

            btnHaut = new AbulEduFlatBoutonV1(this);
            btnHaut->setText(trUtf8("Haut"));
            btnHaut->setObjectName(QString::fromUtf8("btnHaut"));

            gridLayout->addWidget(btnHaut, 2, 4, 1, 1);

            btnBas = new AbulEduFlatBoutonV1(this);
            btnBas->setText(trUtf8("Bas"));
            btnBas->setObjectName(QString::fromUtf8("btnBas"));

            gridLayout->addWidget(btnBas, 3, 4, 1, 1);

            verticalSpacer_2 = new QSpacerItem(20, 71, QSizePolicy::Minimum, QSizePolicy::Expanding);

            gridLayout->addItem(verticalSpacer_2, 4, 4, 1, 1);

            QMetaObject::connectSlotsByName(this);

}

void AbulEduLabelWidgetV1::on_btnHaut_clicked()
{
    qDebug()<<"AbulEduLabelWidget::on_btnHaut_clicked()";
    emit moveSelectedLabelUp();
}
void AbulEduLabelWidgetV1::on_btnBas_clicked()
{
    qDebug()<<"AbulEduLabelWidget::on_btnBas_clicked()";
    emit moveSelectedLabelDown();
}

void AbulEduLabelWidgetV1::on_btnGauche_clicked()
{
    qDebug()<<"AbulEduLabelWidget::on_btnGauche_clicked()";
    emit moveSelectedLabelLeft();
}

void AbulEduLabelWidgetV1::on_btnDroite_clicked()
{
    qDebug()<<"AbulEduLabelWidget::on_btnDroite_clicked()";
    emit moveSelectedLabelRight();
}

void AbulEduLabelWidgetV1::btnDroiteSetVisible(bool on)
{
    btnDroite->setVisible(on);
}
void AbulEduLabelWidgetV1::btnGaucheSetVisible(bool on)
{
    btnGauche->setVisible(on);
}
void AbulEduLabelWidgetV1::btnBasSetVisible(bool on)
{
    btnBas->setVisible(on);
}
void AbulEduLabelWidgetV1::btnHautSetVisible(bool on)
{
    btnHaut->setVisible(on);
}
void AbulEduLabelWidgetV1::btnDroiteSetEnabled(bool on)
{
    btnDroite->setEnabled(on);
}
void AbulEduLabelWidgetV1::btnGaucheSetEnabled(bool on)
{
    btnGauche->setEnabled(on);
}
void AbulEduLabelWidgetV1::btnBasSetEnabled(bool on)
{
    btnBas->setEnabled(on);
}
void AbulEduLabelWidgetV1::btnHautSetEnabled(bool on)
{
    btnHaut->setEnabled(on);
}
void AbulEduLabelWidgetV1::mousePressEvent(QMouseEvent *)
{
    AbulEduLabelFrameV1 *aire = findChild<AbulEduLabelFrameV1 *>();
    aire->abelabelDeselectionneLabels(); // Si on clique en dehors des abuledulabels, on désélectionne tout
}
